<script setup lang="ts">
import { useStore } from "vuex";
import { ref, defineProps } from "vue";
import { HoverState } from "@/types";

const props = defineProps({
  data: Array,
  current: String,
  selectable: Boolean,
  search: String,
  order: Boolean,
  sortable: Boolean,
});

const store = useStore();
const hoverState = ref<HoverState>({});
const sortOrder = ref<boolean>(props.order);

const setHover = (elem: string, value: boolean) =>
  (hoverState.value[elem] = value);
const select = (stop: string) => store.dispatch("selectBusStop", stop);
const handleSort = () => {
  sortOrder.value = !sortOrder.value;
  store.dispatch("handleSort")
};
</script>

<template>
  <div class="bg-white">
    <button v-if="sortable" @click="handleSort" class="border-0 bg-white sort-button">
      <p class="m-0">Bus Stops
        <span class="arrow" v-if="sortOrder">&#9650;</span>
        <span class="arrow" v-else>&#9660;</span>
      </p>
    </button>
    <div>{{ search }}</div>

    <ul class="list-group list-group-flush">
      <li
          @mouseover="setHover(elem, true)"
          @mouseleave="setHover(elem, false)"
          :class="[
        'list-group-item',
        { active: elem === current },
        { hover: hoverState[elem] },
      ]"
          v-for="(elem, index) in data"
          :key="elem + index"
          @click="selectable && select(elem)"
      >
        {{ elem }}
      </li>
    </ul>
  </div>

</template>

<style scoped>
.list-group {
  max-height: initial;
  overflow-y: auto;
}
.list-group-item {
}
.hover {
  background-color: #f8f8fb;
}
.sort-button {
  margin-bottom: 16px;
}

.arrow {
  font-size: 12px;
  margin-left: 4px;
}
</style>
